using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Clipping
{
	/// <summary>
	/// Zusammenfassung fr Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private MyOwnControl label1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.CheckBox checkBox1;
		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Erforderlich fr die Windows Form-Designeruntersttzung
			//
			InitializeComponent();

			//
			// TODO: Fgen Sie den Konstruktorcode nach dem Aufruf von InitializeComponent hinzu
			//
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new Clipping.MyOwnControl();
			this.button1 = new System.Windows.Forms.Button();
			this.checkBox1 = new System.Windows.Forms.CheckBox();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(20, 20);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(200, 100);
			this.label1.TabIndex = 0;
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(88, 184);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(96, 40);
			this.button1.TabIndex = 0;
			this.button1.Text = "button1";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// checkBox1
			// 
			this.checkBox1.Location = new System.Drawing.Point(40, 240);
			this.checkBox1.Name = "checkBox1";
			this.checkBox1.TabIndex = 1;
			this.checkBox1.Text = "Double buffer";
			this.checkBox1.CheckedChanged += new System.EventHandler(this.checkBox1_CheckedChanged);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 273);
			this.Controls.Add(this.checkBox1);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.button1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			// Toggle the color
			label1.TestColor = (label1.TestColor == Color.Blue) ? Color.Red : Color.Blue;
		}

		private void checkBox1_CheckedChanged(object sender, System.EventArgs e)
		{
			label1.DoubleBuffer = checkBox1.Checked;
		}
	}

	class MyOwnControl:System.Windows.Forms.UserControl
	{
		private Color color = Color.Red;

		protected override void OnPaint(PaintEventArgs e)
		{
			Console.WriteLine("ClipRectangle: " + e.ClipRectangle + "  Graphics ClipBounds: "+e.Graphics.ClipBounds); 
			// Check whether we need to redraw the whole control
			if (e.ClipRectangle.Height == this.Height)
			{
				e.Graphics.FillRectangle(Brushes.Pink, 0, 0, Width, 10);
				e.Graphics.FillRectangle(new SolidBrush(color), 0, 10, Width, Height);
			}
			else
			{
				// only draw the necessary parts
				if(e.ClipRectangle.Y < 10)
				{
					e.Graphics.FillRectangle(Brushes.Pink, 0, 0, Width, 10);
				}
				if(e.ClipRectangle.Y >= 10)
				{
					e.Graphics.FillRectangle(new SolidBrush(color), 0, 10, Width, Height);
				}				
			}
		}

		public Color TestColor
		{
			set
			{
				color = value;
				Invalidate(new Rectangle(0, 10, Width, Height));
			}
			get
			{
				return color;
			}
		}

		public bool DoubleBuffer
		{
			set
			{
				// enable double buffer
				SetStyle(ControlStyles.DoubleBuffer  | ControlStyles.UserPaint | ControlStyles.AllPaintingInWmPaint, value);
				Invalidate();
			}
		}

	}
}
